package org.insa.graphs.algorithm.shortestpath;

import org.insa.graphs.model.Graph;
import org.insa.graphs.model.Node;
import org.insa.graphs.model.Point;
import org.insa.graphs.algorithm.AbstractInputData.Mode;

public class AStarAlgorithm extends DijkstraAlgorithm {
	
    public AStarAlgorithm(ShortestPathData data) {
        super(data);
    }
    
    @Override protected void init(Label[] tabLabel, ShortestPathData data)
	{	double maxspeed=data.getMaximumSpeed();
		//System.out.println("Max speed avant: "+maxspeed+"\n");
		
		//System.out.println("Max speed 3: "+maxspeed+"\n");
    	if(data.getMode()==Mode.LENGTH)
		{
			maxspeed=1.0;
		}
    	else
    	{
    		if(maxspeed==-1)
    		{
    			maxspeed=(data.getGraph().getGraphInformation().getMaximumSpeed());
    			//System.out.println("Max speed 2: "+maxspeed+"\n");
    			maxspeed=maxspeed/3.6;
    		}
    	}
    	//System.out.println("Max speed 4: "+maxspeed+"\n");
    	//System.out.println("Origin latitude: "+data.getOrigin().getPoint().getLatitude() +"; origin longitude: "+data.getOrigin().getPoint().getLongitude()+"\n");
    	System.out.println("Destination latitude: "+data.getDestination().getPoint().getLatitude() +"; destination longitude: "+data.getDestination().getPoint().getLongitude()+"\n");
    	//Initialization 
    	for(Node n: data.getGraph().getNodes())
        {
        	
        		tabLabel[n.getId()]=new LabelStar(n,Point.distance(n.getPoint(),data.getDestination().getPoint())/maxspeed);
 
        	
        }
    	
        //tabLabel[data.getOrigin().getId()].setCout(Point.distance(data.getOrigin().getPoint(),data.getDestination().getPoint())/maxspeed);
		
        
	}
    
}
